plugins {
    id("com.android.application") version "7.4.0"
    id("org.jetbrains.kotlin.android") version "1.7.21"
}

android {
    namespace = "io.gitlab.jfronny.hc05ac"
    compileSdk = 33

    defaultConfig {
        applicationId = "io.gitlab.jfronny.hc05ac"
        minSdk = 15
        targetSdk = 33
        versionCode = 1
        versionName = "1.0"
    }

    buildTypes {
        getByName("release") {
            isMinifyEnabled = true
            proguardFiles(getDefaultProguardFile("proguard-android-optimize.txt"), "proguard-rules.pro")
        }
        getByName("debug") {
            isMinifyEnabled = false
        }
    }
    flavorDimensions += "connectivity"
    productFlavors {
        create("demo") {
            dimension = "connectivity"
            applicationIdSuffix = ".demo"
        }
        create("bt") {
            dimension = "connectivity"
            applicationIdSuffix = ".bt"
        }
    }

    compileOptions {
        sourceCompatibility = JavaVersion.VERSION_1_8
        targetCompatibility = JavaVersion.VERSION_1_8
    }
    kotlinOptions {
        jvmTarget = "1.8"
    }
}

dependencies {
    implementation("androidx.core:core-ktx:1.9.0")
    implementation("androidx.appcompat:appcompat:1.6.0")
    implementation("com.google.android.material:material:1.8.0")
    implementation("androidx.constraintlayout:constraintlayout:2.1.4")
}
